// sorgente: VettIO.c

// programma che illustra le modalita' di definizione di un vettore
// a run-time

// inclusione del file di intestazione della libreria standard
// che contiene definizioni di macro, costanti e dichiarazioni
// di funzioni e tipi funzionali alle varie operazioni di I/O
#include <stdio.h>

// inclusione del file di intestazione della libreria standard
// che contiene definizioni di macro, costanti e dichiarazioni
// di funzioni e tipi di interesse generale
#include <stdlib.h>

// funzione per l'acquisizione del contenuto di un vettore di
// interi
void AcqVettInt(int *Vett, size_t dim)
  // Parametri formali
  //    Vett:      indirizzo della prima locazione assegnata
  //               al vettore
  //    dim:       dimensione del vettore
  {
  // definizione della variabile per la scansione del vettore
  int pos;
  
  // scansione del vettore e acquisizione del suo contenuto
  for (pos = 0; pos < dim; pos++)
    {
    printf("\nVett[%d]? ", pos);
    scanf("%d", Vett+pos);
    };
  };
  
// funzione per la restituzione del contenuto di un vettore
// di interi
void ResVettInt(int *Vett, size_t dim)
  // Parametri formali
  //    Vett:      indirizzo della prima locazione assegnata
  //               al vettore
  //    dim:       dimensione del vettore
  {  
  // definizione della variabile per la scansione del vettore
  int pos;
  
  // scansione del vettore e restituzione del suo contenuto
  for (pos = 0; pos < dim; pos++)
    printf("\nVett[%d]: %d", pos, *(Vett+pos));
  };

// funzione per l'allocazione di un buffer la cui
// dimensione e' espressa in numero di interi
int * AllBuffInt(size_t dim)
  // Parametri formali
  //    dim: dimensione del buffer in numero di interi
  {
  // definizione della variabile per lindirizzo
  // iniziale del buffer
  int *ptr;
  
  // allocazione della memoria per il buffer
  ptr = (int *) malloc(dim * sizeof(int));

  // se lallocazione e andata a buon fine restituisce
  // lindirizzo iniziale del buffer; NULL altrimenti

  return(ptr);
  };

// Chiamante
int main()
  {
  // definizione della variabile per il "nome" del vettore
  int *prova;
  
  // definizione e inizializzazione della variabile per la dimensione
  // del vettore
  size_t dim;
  
  printf("\nDimensione del vettore? ");
  scanf("%u", &dim);
  
  // allocazione della memoria per il vettore 
  if ((prova = AllBuffInt(dim)) == NULL)
	 {
	 // se l'allocazione fallisce, visualizza un opportuno messaggio
	 // e termina
	 printf("\nEsito dell'allocazione negativo");
	 return(0);
	 };
	 
  // altrimenti, visualizza un opportuno messaggio, acquisisce e
  // restituisce il contenuto del vettore
  printf("\nEsito dell'allocazione positivo");
  
  printf("\nAcquisizione del contenuto del vettore\n");
  AcqVettInt(prova, dim);
  
  printf("\nRestituzione del contenuto del vettore");
  ResVettInt(prova, dim);
  
  // rilascio della memoria allocata per il vettore
  free(prova);
	
  return(1);
  }
